<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑' : '添加'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="关联分类id" name="cid">
        <a-input
          allow-clear
          placeholder="请输入关联分类id"
          v-model:value="form.cid"
        />
      </a-form-item>
      <a-form-item label="标题" name="title">
        <a-input
          allow-clear
          placeholder="请输入标题"
          v-model:value="form.title"
        />
      </a-form-item>
      <a-form-item label="缩略图" name="thumb">
        <a-input
          allow-clear
          placeholder="请输入缩略图"
          v-model:value="form.thumb"
        />
      </a-form-item>
      <a-form-item label="描述" name="desc">
        <a-input
          allow-clear
          placeholder="请输入描述"
          v-model:value="form.desc"
        />
      </a-form-item>
      <a-form-item label="详细内容" name="content">
        <a-input
          allow-clear
          placeholder="请输入详细内容"
          v-model:value="form.content"
        />
      </a-form-item>
      <a-form-item label="浏览量" name="views">
        <a-input
          allow-clear
          placeholder="请输入浏览量"
          v-model:value="form.views"
        />
      </a-form-item>
      <a-form-item label="是否头条新闻：1是，2不是" name="isHeader">
        <a-input
          allow-clear
          placeholder="请输入是否头条新闻：1是，2不是"
          v-model:value="form.isHeader"
        />
      </a-form-item>
      <a-form-item label="是否弹窗：1是，2不是" name="isAlert">
        <a-input
          allow-clear
          placeholder="请输入是否弹窗：1是，2不是"
          v-model:value="form.isAlert"
        />
      </a-form-item>
      <a-form-item label="失效时间" name="expireTime">
        <a-input
          allow-clear
          placeholder="请输入失效时间"
          v-model:value="form.expireTime"
        />
      </a-form-item>
      <a-form-item label="" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入"
          v-model:value="form.updateTime"
        />
      </a-form-item>
      <a-form-item label="状态：1正常,2下架" name="status">
        <a-radio-group v-model:value="form.status">
          <a-radio :value="0">显示</a-radio>
          <a-radio :value="1">隐藏</a-radio>
        </a-radio-group>
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addThinkNews, updateThinkNews } from '@/api/think/thinkNews';
  import { ThinkNews } from '@/api/think/thinkNews/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkNews | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ThinkNews>({
    id: undefined,
    cid: undefined,
    title: undefined,
    thumb: undefined,
    desc: undefined,
    content: undefined,
    views: undefined,
    isHeader: undefined,
    isAlert: undefined,
    expireTime: undefined,
    createTime: undefined,
    updateTime: undefined,
    status: undefined,
    thinkNewsId: undefined,
    thinkNewsName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkNewsName: [
      {
        required: true,
        type: 'string',
        message: '请填写名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateThinkNews : addThinkNews;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
